(***********************************************************************)
(*                                                                     *)
(*                              Ref-image                              *)
(*                                                                     *)
(*                  Image Segmentation by Refinement                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2009-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: uindex_index.ml,v 1.8 2017/05/31 16:38:11 fclement Exp $*)

(* The type of index indices. *)

type 'a element = 'a Uindex.t;;
type 'a index = 'a element Uindex.t;;

let to_index = Uindex.to_t
and of_index = Uindex.of_t
;;

let of_nat = Uindex.of_nat
and to_nat = Uindex.to_nat
;;

let of_int = Uindex.of_int
and to_int = Uindex.to_int
;;

let _0_ = Uindex._0_
and _1_ = Uindex._1_
;;

let succ = Uindex.succ
and pred = Uindex.pred
;;
