(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: hashtbl_print_xml.ml,v 1.4 2017/05/31 15:24:07 fclement Exp $ *)

let printer_xml_statistics ctx ppf = function
  | {
      Hashtbl.num_bindings = i;
      Hashtbl.num_buckets = i0;
      Hashtbl.max_bucket_length = i1;
      Hashtbl.bucket_histogram = i_a;
    } ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><record>@,";
    Format.fprintf ppf "%,@[<hv 2><lident>@,"; Format.fprintf ppf "%,Hashtbl";
    Format.fprintf ppf "%,@;<0 -2></lident>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><num_bindings>@,";
    Og_printer_xml.printer_xml_Int Og_precedence.Ck_record_field ppf i;
    Format.fprintf ppf "%,@;<0 -2></num_bindings>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><num_buckets>@,";
    Og_printer_xml.printer_xml_Int Og_precedence.Ck_record_field ppf i0;
    Format.fprintf ppf "%,@;<0 -2></num_buckets>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><max_bucket_length>@,";
    Og_printer_xml.printer_xml_Int Og_precedence.Ck_record_field ppf i1;
    Format.fprintf ppf "%,@;<0 -2></max_bucket_length>@]";
    Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><bucket_histogram>@,";
    Og_printer_xml.printer_xml_Array Og_printer_xml.printer_xml_Int
      Og_precedence.Ck_record_field
      ppf
      i_a;
    Format.fprintf ppf "%,@;<0 -2></bucket_histogram>@]";
    Format.fprintf ppf "%,@;<0 -2></record>@]"
;;

(* Defining top printers. *)

let print_xml_statistics ppf =
  printer_xml_statistics Og_precedence.Ck_toplevel ppf
;;
