(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_arrow_number ctx ppf = function
  | u_a -> Udynamic_graph_print.printer_arrow_number ctx ppf u_a
;;

let printer_delayed_image pp_b ctx ppf = function
  | Udelayed_dgraph_types.Not_yet_computed ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Not_yet_computed"
  | Udelayed_dgraph_types.Image b ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Image";
    pp_b Og_precedence.Ck_argument ppf b; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
;;

let printer_delayed_arrow pp_a pp_b ctx ppf = function
  | a_b_d_u_a ->
    Udynamic_graph_print.printer_arrow pp_a (printer_delayed_image pp_b)
      ctx
      ppf
      a_b_d_u_a
;;

let rec printer_t pp_a pp_b pp_c ctx ppf = function
  | {
      Udelayed_dgraph_types.f = f_c_f_a_f_a_b;
      Udelayed_dgraph_types.graph = a_b_d_u_t;
      Udelayed_dgraph_types.to_do = a_l;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,@[<hv 2>f =";
    Og_printer.printer_Fun
      pp_c
      (Og_printer.printer_Fun
         printer_arrow_number
         (Og_printer.printer_Fun pp_a pp_b))
      Og_precedence.Ck_record_field
      ppf
      f_c_f_a_f_a_b;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>graph =";
    Udynamic_graph_print.printer_t pp_a (printer_delayed_image pp_b)
      Og_precedence.Ck_record_field
      ppf
      a_b_d_u_t;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>to_do =";
    Og_printer.printer_List printer_arrow_number
      Og_precedence.Ck_record_field
      ppf
      a_l;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"

and printer_delayed_dgraph pp_a pp_b pp_c ctx ppf = function
  | a_b_c_t -> printer_t pp_a pp_b pp_c ctx ppf a_b_c_t
;;

(* Defining top printers. *)

let print_arrow_number ppf =
  printer_arrow_number Og_precedence.Ck_toplevel ppf
;;

let print_delayed_image pp_b ppf =
  printer_delayed_image pp_b Og_precedence.Ck_toplevel ppf
;;

let print_delayed_arrow pp_a pp_b ppf =
  printer_delayed_arrow pp_a pp_b Og_precedence.Ck_toplevel ppf
;;

let print_t pp_a pp_b pp_c ppf =
  printer_t pp_a pp_b pp_c Og_precedence.Ck_toplevel ppf

and print_delayed_dgraph pp_a pp_b pp_c ppf =
  printer_delayed_dgraph pp_a pp_b pp_c Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
