(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_length ctx ppf = function
  | u_l -> Ustamped_darray_print.printer_length ctx ppf u_l
;;

let printer_arrow_number ctx ppf = function
  | u_i -> Ustamped_darray_print.printer_index ctx ppf u_i
;;

let printer_arrow pp_a pp_b ctx ppf = function
  | { Udynamic_graph.value = a; Udynamic_graph.image = b; } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,@[<hv 2>value =";
    pp_a Og_precedence.Ck_record_field ppf a; Format.fprintf ppf "%,;@]";
    Format.fprintf ppf "%,@ "; Format.fprintf ppf "%,@[<hv 2>image =";
    pp_b Og_precedence.Ck_record_field ppf b; Format.fprintf ppf "%,;@]";
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let rec printer_t pp_a pp_b ctx ppf = function
  | a_b_a_u_t ->
    Ustamped_darray_print.printer_t (printer_arrow pp_a pp_b)
      ctx
      ppf
      a_b_a_u_t

and printer_dynamic_graph pp_a pp_b ctx ppf = function
  | a_b_t -> printer_t pp_a pp_b ctx ppf a_b_t
;;

(* Defining top printers. *)

let print_length ppf = printer_length Og_precedence.Ck_toplevel ppf
;;

let print_arrow_number ppf =
  printer_arrow_number Og_precedence.Ck_toplevel ppf
;;

let print_arrow pp_a pp_b ppf =
  printer_arrow pp_a pp_b Og_precedence.Ck_toplevel ppf
;;

let print_t pp_a pp_b ppf = printer_t pp_a pp_b Og_precedence.Ck_toplevel ppf

and print_dynamic_graph pp_a pp_b ppf =
  printer_dynamic_graph pp_a pp_b Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
