(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_xml_length ctx ppf = function
  | u_l -> Ustamped_darray_print_xml.printer_xml_length ctx ppf u_l
;;

let printer_xml_arrow_number ctx ppf = function
  | u_i -> Ustamped_darray_print_xml.printer_xml_index ctx ppf u_i
;;

let printer_xml_arrow px_a px_b ctx ppf = function
  | { Udynamic_graph.value = a; Udynamic_graph.image = b; } ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><record>@,";
    Format.fprintf ppf "%,@[<hv 2><value>@,";
    px_a Og_precedence.Ck_record_field ppf a;
    Format.fprintf ppf "%,@;<0 -2></value>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><image>@,";
    px_b Og_precedence.Ck_record_field ppf b;
    Format.fprintf ppf "%,@;<0 -2></image>@]";
    Format.fprintf ppf "%,@;<0 -2></record>@]"
;;

let rec printer_xml_t px_a px_b ctx ppf = function
  | a_b_a_u_t ->
    Ustamped_darray_print_xml.printer_xml_t (printer_xml_arrow px_a px_b)
      ctx
      ppf
      a_b_a_u_t

and printer_xml_dynamic_graph px_a px_b ctx ppf = function
  | a_b_t -> printer_xml_t px_a px_b ctx ppf a_b_t
;;

(* Defining top printers. *)

let print_xml_length ppf = printer_xml_length Og_precedence.Ck_toplevel ppf
;;

let print_xml_arrow_number ppf =
  printer_xml_arrow_number Og_precedence.Ck_toplevel ppf
;;

let print_xml_arrow px_a px_b ppf =
  printer_xml_arrow px_a px_b Og_precedence.Ck_toplevel ppf
;;

let print_xml_t px_a px_b ppf =
  printer_xml_t px_a px_b Og_precedence.Ck_toplevel ppf

and print_xml_dynamic_graph px_a px_b ppf =
  printer_xml_dynamic_graph px_a px_b Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
