(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_xml_uindex px_a ctx ppf = function
  | a_u_i -> Uuniverse_print_xml.printer_xml_index px_a ctx ppf a_u_i
;;

let printer_xml_index px_a ctx ppf = function
  | a_u_u -> printer_xml_uindex (printer_xml_uindex px_a) ctx ppf a_u_u
;;

let rec printer_xml_t px_a ctx ppf = function
  | {
      Unonempty_set_types.universe = a_u_t;
      Unonempty_set_types.uindices = a_u_u_t;
    } ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><record>@,";
    Format.fprintf ppf "%,@[<hv 2><universe>@,";
    Uuniverse_print_xml.printer_xml_t px_a
      Og_precedence.Ck_record_field
      ppf
      a_u_t;
    Format.fprintf ppf "%,@;<0 -2></universe>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><uindices>@,";
    Uuniverse_print_xml.printer_xml_t (printer_xml_uindex px_a)
      Og_precedence.Ck_record_field
      ppf
      a_u_u_t;
    Format.fprintf ppf "%,@;<0 -2></uindices>@]";
    Format.fprintf ppf "%,@;<0 -2></record>@]"

and printer_xml_nonempty_set px_a ctx ppf = function
  | a_t -> printer_xml_t px_a ctx ppf a_t
;;

(* Defining top printers. *)

let print_xml_uindex px_a ppf =
  printer_xml_uindex px_a Og_precedence.Ck_toplevel ppf
;;

let print_xml_index px_a ppf =
  printer_xml_index px_a Og_precedence.Ck_toplevel ppf
;;

let print_xml_t px_a ppf = printer_xml_t px_a Og_precedence.Ck_toplevel ppf

and print_xml_nonempty_set px_a ppf =
  printer_xml_nonempty_set px_a Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
