(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let rec printer_xml_length ctx ppf = function
  | u_l -> Usubarray_types_print_xml.printer_xml_length ctx ppf u_l

and printer_xml_index ctx ppf = function
  | u_i -> Usubarray_types_print_xml.printer_xml_index ctx ppf u_i

and printer_xml_offset ctx ppf = function
  | u_o -> Usubarray_types_print_xml.printer_xml_offset ctx ppf u_o

and printer_xml_range ctx ppf = function
  | u_r -> Usubarray_types_print_xml.printer_xml_range ctx ppf u_r

and printer_xml_indices ctx ppf = function
  | u_i -> Usubarray_types_print_xml.printer_xml_indices ctx ppf u_i

and printer_xml_t px_a ctx ppf = function
  | a_u_t -> Usubarray_types_print_xml.printer_xml_t px_a ctx ppf a_u_t

and printer_xml_subarray px_a ctx ppf = function
  | a_t -> printer_xml_t px_a ctx ppf a_t
;;

(* Defining top printers. *)

let print_xml_length ppf = printer_xml_length Og_precedence.Ck_toplevel ppf

and print_xml_index ppf = printer_xml_index Og_precedence.Ck_toplevel ppf

and print_xml_offset ppf = printer_xml_offset Og_precedence.Ck_toplevel ppf

and print_xml_range ppf = printer_xml_range Og_precedence.Ck_toplevel ppf

and print_xml_indices ppf = printer_xml_indices Og_precedence.Ck_toplevel ppf

and print_xml_t px_a ppf = printer_xml_t px_a Og_precedence.Ck_toplevel ppf

and print_xml_subarray px_a ppf =
  printer_xml_subarray px_a Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
