(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_xml_length ctx ppf = function
  | u_l -> Uarray_print_xml.printer_xml_length ctx ppf u_l

and printer_xml_index ctx ppf = function
  | u_i -> Uarray_print_xml.printer_xml_index ctx ppf u_i

and printer_xml_offset ctx ppf = function
  | u_o -> Uarray_print_xml.printer_xml_offset ctx ppf u_o
;;

let printer_xml_range ctx ppf = function
  | { Usubarray_types.offset = o; Usubarray_types.length = l; } ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><record>@,";
    Format.fprintf ppf "%,@[<hv 2><offset>@,";
    printer_xml_offset Og_precedence.Ck_record_field ppf o;
    Format.fprintf ppf "%,@;<0 -2></offset>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><length>@,";
    printer_xml_length Og_precedence.Ck_record_field ppf l;
    Format.fprintf ppf "%,@;<0 -2></length>@]";
    Format.fprintf ppf "%,@;<0 -2></record>@]"
;;

let printer_xml_indices ctx ppf = function
  | Usubarray_types.Range r ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><constructor>@,";
    Format.fprintf ppf "%,@[<hv 2><lident>@,"; Format.fprintf ppf "%,Range";
    Format.fprintf ppf "%,@;<0 -2></lident>@]"; Format.fprintf ppf "%,@,";
    printer_xml_range Og_precedence.Ck_argument ppf r;
    Format.fprintf ppf "%,@;<0 -2></constructor>@]"
  | Usubarray_types.Indices i_a ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><constructor>@,";
    Format.fprintf ppf "%,@[<hv 2><lident>@,";
    Format.fprintf ppf "%,Indices";
    Format.fprintf ppf "%,@;<0 -2></lident>@]"; Format.fprintf ppf "%,@,";
    Og_printer_xml.printer_xml_Array printer_xml_index
      Og_precedence.Ck_argument
      ppf
      i_a;
    Format.fprintf ppf "%,@;<0 -2></constructor>@]"
;;

let rec printer_xml_t px_a ctx ppf = function
  | { Usubarray_types.support = a_a; Usubarray_types.indices = i; } ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><record>@,";
    Format.fprintf ppf "%,@[<hv 2><support>@,";
    Og_printer_xml.printer_xml_Array px_a
      Og_precedence.Ck_record_field
      ppf
      a_a;
    Format.fprintf ppf "%,@;<0 -2></support>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><indices>@,";
    printer_xml_indices Og_precedence.Ck_record_field ppf i;
    Format.fprintf ppf "%,@;<0 -2></indices>@]";
    Format.fprintf ppf "%,@;<0 -2></record>@]"

and printer_xml_subarray px_a ctx ppf = function
  | a_t -> printer_xml_t px_a ctx ppf a_t
;;

(* Defining top printers. *)

let print_xml_length ppf = printer_xml_length Og_precedence.Ck_toplevel ppf

and print_xml_index ppf = printer_xml_index Og_precedence.Ck_toplevel ppf

and print_xml_offset ppf = printer_xml_offset Og_precedence.Ck_toplevel ppf
;;

let print_xml_range ppf = printer_xml_range Og_precedence.Ck_toplevel ppf
;;

let print_xml_indices ppf = printer_xml_indices Og_precedence.Ck_toplevel ppf
;;

let print_xml_t px_a ppf = printer_xml_t px_a Og_precedence.Ck_toplevel ppf

and print_xml_subarray px_a ppf =
  printer_xml_subarray px_a Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
