(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: uarray2_with_fortran_layout.mli,v 1.16 2017/05/31 15:24:06 fclement Exp $ *)

(** {3 More operations on two-dimensional bigarrays with Fortran layout} *)

open Bigarray;;

(** {6 Iterators} *)

val iter : ('a -> unit) -> ('a, 'b, fortran_layout) Array2.t -> unit
(** [iter f a] applies function [f] in turn to all
    the elements of the bigarray [a]. *)
;;

val iter_ij :
    (int -> int -> 'a -> unit) -> ('a, 'b, fortran_layout) Array2.t -> unit
(** Same as {!iter}, but the function is applied
    to the indices of the element as first and second arguments, and the element
    itself as third argument. *)
;;
