(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: uuniverse_types.mli,v 1.3 2017/05/31 15:24:06 fclement Exp $*)

(** {3 The private type of universes} *)

type 'a index = 'a Uindex.t;;

type 'a indices;;
type 'a elements = 'a array;;

type 'a t = private
  {
   indices : 'a indices;
   mutable elements : 'a elements;
   mutable cardinal : Unatural.t;
  }
and 'a universe = 'a t
;;

val make : Unatural.t -> 'a -> 'a t;;
val copy : 'a t -> 'a t;;

val mem : 'a t -> 'a -> bool;;
val index : 'a t -> 'a -> 'a index;;
val stats : 'a t -> Hashtbl.statistics;;

(**/**)
(** {6 Undocumented features} *)

val unsafe_make : Unatural.t -> 'a -> 'a t;;
val unsafe_add : 'a t -> 'a -> unit;;
